define plasma_shootspeed=4; 
define plasma_shootspeed_sek=0.25; 

define rocket_shootspeed=10.66; 
define rocket_shootspeed_sek=.666; 
define plasma_speed=110;
define rocket_speed=50;
define plasma_damage=15;
var shootit; 
function bullet_collision_box()
{
  wait(1);
  my.narrow=off;my.fat=off;
  my.max_x=0;
  my.min_x=0;
  my.max_y=0;
  my.min_y=0;
  my.max_z=0;
  my.min_z=0;
}
action impact_model
{
  my.passable=on;my.bright=on;
  my.unlit=on;
  my.transparent=on;
  my.alpha=100;
  
  
  vec_to_angle(my.pan, normal); 
  
  
  if(you.my_bullet_impactsound!=0)
  {
  ent_playsound(my,you.my_bullet_impactsound,400);
  }
  
  my.oriented = on;	
  my.facing = off;	
  while(my.alpha>0)
  {
  my.alpha-=time*5;
  wait(1);
  }
  ent_remove(my);
  

}
action rocketrauch
{
my.passable=on;
my.x+=random(8)-4;
my.z+=random(8)-4;
my.y+=random(8)-4;

my.facing=on;
sleep(1);
ent_remove(my);
}

action rocketexplosion
{
my.passable=on;
my.bright=on;
my.flare=on;
my.facing=on;
my.unlit=on;
my.ambient=100;
my.albedo=0;
sleep(1.5);
ent_remove(my);
}


action bullet
{
  var bulletturn;
  var raucher;
  
  var old_pan;var old_tilt;
  var too_strong_reflection;
  
  bulletturn=random(50)-25;
  
  my.are_you_bullet=is_a_bullet; 
  my.fraction=you.fraction;
  bullet_collision_box();
  var movning_it[3];
  var movedistance;
  var kill_me;
  my.narrow=off;
  my.passable=on;
  my.fat=off;
   wait(1);

 my.passable=off;
  
   move_mode = ignore_you+ignore_models+ignore_sprites+ignore_passable;
    movning_it.x=20;
    movedistance=ent_move(movning_it.x,nullvector);
  while(1)
  {
    while(shootit==0)
    {
    movning_it.x=time*my.my_bullet_speed;
    
    my.roll+=time*bulletturn;
      move_mode = ignore_you+ignore_sprites+ignore_passable;
    vec_set(bounce.pan,nullvector);
    movedistance=ent_move(movning_it.x,nullvector);
    if(my.my_bullet_smokemodel!=0)
    {raucher-=time;
    if(raucher<=0){ent_create(ptr_for_handle(my.my_bullet_smokemodel),my.x,rocketrauch);raucher=.5;}
    }
    kill_me+=time;
    if((kill_me>my.my_bullet_timeout)||(movning_it.x*.5>movedistance))
      {
      if(my.my_bullet_damageradius>0)  
      {make_rocket_explosion(my.x,my.y,my.z);}
      
      my.invisible=on;
      my.passable=on;
      ent_create(ptr_for_handle(my.my_bullet_impactmodel),my.x,impact_model);
       sleep(2);ent_remove(my);return;}
    wait(1);
    }
  }
}
entity* free_bot_pointer;
function make_rocket_explosion(aa,bb,cc)
{
var rocket_boom_distance;
var rocket_damage;
rocket_boom_distance=my.my_bullet_damageradius;
rocket_damage=my.my_bullet_damage;
var i=0;
var thebulletdamage;
  while(i<bot_number)
  {
          free_bot_pointer=ptr_for_handle(bot_list[i]);
          if(free_bot_pointer.health>0)
          {
              if(vec_dist(my.x,free_bot_pointer.x)<rocket_boom_distance)
              {
              
              vec_set(temp.x,free_bot_pointer.x);
              temp.z+=40;
              
              trace_mode = ignore_me + ignore_models + ignore_sprites;
              temp2.x=aa;temp2.y=bb;temp2.z=cc;
              if(trace(temp.x,temp2.x)==0)
                         
              {
              
              vec_set(temp.x,free_bot_pointer.x);
              temp.z+=40;
              
              free_bot_pointer.shield-=(rocket_damage*(rocket_boom_distance-vec_dist(my.x, temp.x))/rocket_boom_distance);
   
               if(free_bot_pointer.shield<0)
               {
               free_bot_pointer.health+=free_bot_pointer.shield;
               free_bot_pointer.shield=0;
               }
              
              }           
              
              }
            
          
           }
  i+=1;
  }
}







action mussleflash
{
my.transparent=on;
my.alpha=30;
    
    proc_late();
    my.passable=on;
    vec_set(my.pan,you.pan);
    var timeout=2;  //time in ticks until model vanishes
    while(timeout>0)
    {
    timeout-=time;
    vec_set(my.x,you.x);
    if(you!=player){my.z+=bot_shoot_z_offset;}
    else{my.z+=player_shoot_z_offset;}
   
    vec_set(my.pan,you.pan);
    if(you==player){my.tilt=camera.tilt;}
    my.roll=random(360);
    wait(1);
    }
    
    ent_remove(my);
}


define weapon_player_volume=50;
string* string_spawnbullet;
string* string_mussleflash;
entity* spawnbullet_ptr;
function spawn_bullet_of_type(thebullettype,alternative_fire)
{
var bulletposition[3];
if(alternative_fire){string_spawnbullet=ptr_for_handle(weapon_bulletmodel_alternative[thebullettype]);}
else{string_spawnbullet=ptr_for_handle(weapon_bulletmodel[thebullettype]);}
vec_set(bulletposition.x,my.x);
if(my==player){bulletposition.z+=player_shoot_z_offset;}  
else{bulletposition.z+=bot_shoot_z_offset;} 
spawnbullet_ptr=ent_create(string_spawnbullet,bulletposition.x,bullet);
if(my==player)
{
spawnbullet_ptr.pan=camera.pan;
spawnbullet_ptr.tilt=camera.tilt;

}
else{
spawnbullet_ptr.pan=my.pan;
spawnbullet_ptr.tilt=my.my_shoot_tilt;

}
if(alternative_fire)
{
spawnbullet_ptr.my_bullet_smokemodel=weapon_bulletsmokemodel_alternative[thebullettype];
}
else
{
spawnbullet_ptr.my_bullet_smokemodel=weapon_bulletsmokemodel[thebullettype];
}
if(my==player)
{
  if(alternative_fire)
  {
  
  spawnbullet_ptr.pan+=random(weapon_recoil_alternative[thebullettype])-weapon_recoil_alternative[thebullettype]*.5;
  spawnbullet_ptr.tilt+=random(weapon_recoil_alternative[thebullettype])-weapon_recoil_alternative[thebullettype]*.5;
  }
  else
  {
  spawnbullet_ptr.pan+=random(weapon_recoil[thebullettype])-weapon_recoil[thebullettype]*.5;
  spawnbullet_ptr.tilt+=random(weapon_recoil[thebullettype])-weapon_recoil[thebullettype]*.5;
  }
}
else
{

 if(alternative_fire)
  {
  
  spawnbullet_ptr.pan+=my.my_shoot_precision*(random(weapon_recoil_bot_alternative[thebullettype])-weapon_recoil_alternative[thebullettype]*.5);
  spawnbullet_ptr.tilt+=my.my_shoot_precision*(random(weapon_recoil_bot_alternative[thebullettype])-weapon_recoil_alternative[thebullettype]*.5);
  }
  else
  {
  spawnbullet_ptr.pan+=my.my_shoot_precision*(random(weapon_recoil_bot[thebullettype])-weapon_recoil[thebullettype]*.5);
  spawnbullet_ptr.tilt+=my.my_shoot_precision*(random(weapon_recoil_bot[thebullettype])-weapon_recoil[thebullettype]*.5);
  }


}



if(weapon_shoottype[thebullettype]==shoottype_beamshot)
{

if(my==player)
{

  temp2.x = 1024/2;
  temp2.y = 768/2;
 	temp2.z = 40;
 	vec_for_screen(temp2,camera);
 
  temp.x = 1024/2;
  temp.y = 768/2;
 	temp.z = 2000;
 	vec_for_screen(temp,camera);
 
}
else
{
 vec_set(temp2.x,my.x);
 
 temp2.z+=bot_shoot_z_offset;
 
 
  my_targetbot_ptr=ptr_for_handle(bot_list[my.target_bot]);
  if(my_targetbot_ptr==player)
  {vec_set(temp.x,my_targetbot_ptr.x);}
  else
  {vec_set(temp.x,my_targetbot_ptr.x);temp.z+=bot_shoot_z_offset;}
   


} 
 
 trace_mode = ignore_models+ignore_sprites;
	
trace(temp2.x,temp.x);



 weapon_drawlaser(vector(target.x,target.y,target.z-20),vector(temp2.x,temp2.y,temp2.z-20));


}
if(my==player)  
{
  if(alternative_fire){snd_play(weapon_shootsound_alternative[thebullettype],weapon_player_volume,0);}
  else{snd_play(weapon_shootsound[thebullettype],weapon_player_volume,0);}
}
else
{
  if(alternative_fire){ent_playsound(my,weapon_shootsound_alternative[thebullettype],300);}
  else{ent_playsound(my,weapon_shootsound[thebullettype],300);}

}
if(alternative_fire){string_mussleflash=ptr_for_handle(weapon_mussleflash_alternative[thebullettype]);}
else{string_mussleflash=ptr_for_handle(weapon_mussleflash[thebullettype]);}

ent_create(string_mussleflash,my.x,mussleflash);
if(alternative_fire)
{
  spawnbullet_ptr.my_bullet_damage=weapon_damage_alternative[thebullettype];
  spawnbullet_ptr.my_bullet_damage_random=weapon_damage_random_alternative[thebullettype];
  spawnbullet_ptr.my_bullet_smokemodel=weapon_bulletsmokemodel_alternative[thebullettype];
  spawnbullet_ptr.my_bullet_impactmodel=weapon_impactmodel_alternative[thebullettype];
  spawnbullet_ptr.my_bullet_impactsound=weapon_impactsound_alternative[thebullettype];
  spawnbullet_ptr.my_bullet_timeout=weapon_timeout_alternative[thebullettype];
  spawnbullet_ptr.my_bullet_speed=weapon_speed_alternative[thebullettype];
  spawnbullet_ptr.my_bullet_damageradius=weapon_impactradius_alternative[thebullettype];
}
else
{
  spawnbullet_ptr.my_bullet_damage=weapon_damage[thebullettype];
  spawnbullet_ptr.my_bullet_damage_random=weapon_damage_random[thebullettype];
  spawnbullet_ptr.my_bullet_smokemodel=weapon_bulletsmokemodel[thebullettype];
  spawnbullet_ptr.my_bullet_impactmodel=weapon_impactmodel[thebullettype];
  spawnbullet_ptr.my_bullet_impactsound=weapon_impactsound[thebullettype];
  spawnbullet_ptr.my_bullet_timeout=weapon_timeout[thebullettype];
  spawnbullet_ptr.my_bullet_speed=weapon_speed[thebullettype];
  spawnbullet_ptr.my_bullet_damageradius=weapon_impactradius[thebullettype];
}

}
bmap laser_bmap="rocket_explosion.tga";

function laser_decay()
{
my.alpha -= time+time;
  if (my.alpha <= 0) { my.lifespan = 0; }
}
function drawlaser()
{
	my.red = 255;
	my.green = 0;
	my.blue = 0;
	my.size = 4;
	my.lifespan = 25;
	my.streak = on;
	my.function = laser_decay;
	my.bright=on;
	my.flare=on;
}
function weapon_drawlaser(&starte,&ende)
{
var tempus[3];
	vec_diff(tempus,ende,starte);
	effect(drawlaser,1,starte,tempus);
}
var thebulletdamage;

function bot_event 
{
  if (event_type == event_impact) 
  {
     if(you.are_you_bullet==is_a_bullet)
    {
    if(my==player){flash_redpanel();}
    if(you.my_bullet_damageradius>0){return;}  
   thebulletdamage=you.my_bullet_damage+int(random(you.my_bullet_damage_random));  //damage+20%random of it
    if(insta_gib){thebulletdamage=10000;}
   if((my.fraction==you.fraction)&&(my.fraction!=free_villian))
   {thebulletdamage*=friendly_fire;}
   
   my.shield-=thebulletdamage;
   
   if(my.shield<0){my.health+=my.shield;my.shield=0;}
   
  
    }
  }
  
}
function flash_redpanel()
{
my=null;
 got_hit_panel.visible=on;
 
 waitt(2);
 got_hit_panel.visible=off;
}
action blood_splatter
{
  var sizer;
  my.passable=on;
   my.oriented = on;	
    my.facing = off;	
   my.transparent=on;
   my.alpha=100;
   
   sizer=random(.7)+.1;
   my.scale_x=sizer;
   my.scale_y=sizer;
     
     
  vec_to_angle(my.pan, normal); 
    
  sleep(100);
  
  while(my.alpha>0)
  {
  my.alpha-=time;
  wait(1);
  }
  
  ent_remove(my);

}


function make_splatter
{
if(no_gore){return;}

var i=0;
var my_position[3];
vec_set(my_position.x,my.x);
while(i<20)
{

temp.z+=30;
vec_set(temp2.x,my_position.x);

temp2.x+=random(600)-300;
temp2.y+=random(600)-300;
temp2.z+=random(600)-300;

trace_mode = ignore_models+ignore_sprites;

if(trace(my_position.x,temp2.x)!=0)
{

ent_create("blood_1.tga",target.x,blood_splatter);

}
wait(1);
i+=1;

}
}